Properties Methods Events Direct Link

# Class Ext.KeyMap

Package: | Ext
Defined In: | KeyMap.js
Class: | KeyMap
Extends: | Object

Handles mapping keys to actions for an element. One key map can be used for multiple actions. The constructor accepts the same config object as defined by addBinding. If you bind a callback function to a KeyMap, anytime the KeyMap handles an expected key combination it will call the function with this signature (if the match is a multi-key combination the callback will still be called only once): (String key, Ext.EventObject e) A KeyMap can also handle a string representation of keys.
Usage:

    // map one key by key code
    var map = new Ext.KeyMap("my-element", {
        key: 13, // or Ext.EventObject.ENTER
        fn: myHandler,
        scope: myObject
    });

    // map multiple keys to one action by string
    var map = new Ext.KeyMap("my-element", {
        key: "a\r\n\t",
        fn: myHandler,
        scope: myObject
    });

    // map multiple keys to multiple actions by strings and array of codes
    var map = new Ext.KeyMap("my-element", [
        {
            key: [10,13],
            fn: function(){ alert("Return was pressed"); }
        }, {
            key: "abc",
            fn: function(){ alert('a, b or c was pressed'); }
        }, {
            key: "\t",
            ctrl:true,
            shift:true,
            fn: function(){ alert('Control + shift + tab was pressed.'); }
        }
    ]);

Note: A KeyMap starts enabled

## Public Properties

Property | Defined By
--- | ---
| stopEvent : Boolean True to stop the event from bubbling and prevent the default browser action if the key was handled by the KeyMap (def... True to stop the event from bubbling and prevent the default browser action if the key was handled by the KeyMap (defaults to false) | KeyMap

## Public Methods

Method | Defined By
--- | ---

KeyMap( `Mixed el`, `Object config`, [`String eventName`] )
Parameters:

- `el` : Mixed
  The element to bind to
- `config` : Object
  The config (see addBinding)
- `eventName` : String
  (optional) The event to bind to (defaults to "keydown")

Returns:

- ``

KeyMap

addBinding( `Object/Array config` ) : void
Add a new binding to this KeyMap. The following config object properties are supported: Property Type ...
Add a new binding to this KeyMap. The following config object properties are supported:

    Property    Type             Description
    ----------  ---------------  ----------------------------------------------------------------------
    key         String/Array     A single keycode or an array of keycodes to handle
    shift       Boolean          True to handle key only when shift is pressed (defaults to false)
    ctrl        Boolean          True to handle key only when ctrl is pressed (defaults to false)
    alt         Boolean          True to handle key only when alt is pressed (defaults to false)
    handler     Function         The function to call when KeyMap finds the expected key combination
    fn          Function         Alias of handler (for backwards-compatibility)
    scope       Object           The scope of the callback function

Usage:

    // Create a KeyMap
    var map = new Ext.KeyMap(document, {
        key: Ext.EventObject.ENTER,
        fn: handleKey,
        scope: this
    });

    //Add a new binding to the existing KeyMap later
    map.addBinding({
        key: 'abc',
        shift: true,
        fn: handleKey,
        scope: this
    });

Parameters:

- `config` : Object/Array
  A single KeyMap config or an array of configs

Returns:

- `void`

KeyMap

disable() : void
Disable this KeyMap
Disable this KeyMap
Parameters:

- None.

Returns:

- `void`

KeyMap

enable() : void
Enables this KeyMap
Enables this KeyMap
Parameters:

- None.

Returns:

- `void`

KeyMap

isEnabled() : Boolean
Returns true if this KeyMap is enabled
Returns true if this KeyMap is enabled
Parameters:

- None.

Returns:

- `Boolean`

KeyMap

on( `Number/Array/Object key`, `Function fn`, [`Object scope`] ) : void
Shorthand for adding a single key listener
Shorthand for adding a single key listener
Parameters:

- `key` : Number/Array/Object
  Either the numeric key code, array of key codes or an object with the following options: {key: (number or array), shift: (true/false), ctrl: (true/false), alt: (true/false)}
- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function

Returns:

- `void`

KeyMap

## Public Events

This class has no public events.